package com.ruoyi.ehsRescueTeam.mapper;

import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.ruoyi.ehsRescueTeam.domain.EhsRescueTeam;
import com.ruoyi.ehsRescueTeam.vo.TeamResponseVo;
import org.apache.ibatis.annotations.Param;

import java.util.List;

/**
 * 应急救援队伍管理Mapper接口
 *
 * @author ruoyi
 * @date 2023-12-11
 */
public interface EhsRescueTeamMapper extends BaseMapper<EhsRescueTeam> {
    /**
     * 查询应急救援队伍管理
     *
     * @param id 应急救援队伍管理主键
     * @return 应急救援队伍管理
     */
    public EhsRescueTeam selectEhsRescueTeamById(Long id);

    /**
     * 查询应急救援队伍管理列表
     *
     * @param ehsRescueTeam 应急救援队伍管理
     * @return 应急救援队伍管理集合
     */
    public List<EhsRescueTeam> selectEhsRescueTeamList(EhsRescueTeam ehsRescueTeam);

    /**
     * 根据营救救援队伍id，查询该队伍人数
     * @param id
     * @return
     */
    public Long getWorkerNumByTeamId(@Param("id") Long id);

    /**
     * 应急救援:根据队伍id获取队伍信息
     */
    public TeamResponseVo getTeamInfoByTeamId(Long rescueTeamId);
}
